#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "common.h"
#include "info_rtt.h"

#include <math.h>
#include <stdio.h>
#include <stdlib.h>



void
rtt_make_stats(struct rtt *ping, struct request *reqs, size_t req_n)
{
	int rtt_med_i;
	int rtt;
	size_t i;

	ping->min = ping->max = -1;
	ping->med = 0;
	ping->recv = 0;

	for (i = 0; i < req_n; i++) {
		struct request *req = &reqs[i];
		if (&req->recv.tv_sec == 0) {
			continue;
		}

		rtt = timediff(&req->recv, &req->sent);
		if (rtt > ping->max || ping->max == -1) {
			ping->max = rtt;
		}
		if (rtt < ping->min || ping->min == -1) {
			ping->min = rtt;
		}
		ping->avg += rtt;
		ping->recv++;
	}
	ping->avg /= ping->recv;

	rtt_med_i = 0;
	for (i = 0; i < req_n; i++) {
		struct request *req = &reqs[i];
		double d;
		if (&req->recv.tv_sec == 0) {
			continue;
		}

		d = ping->avg - (double) timediff(&req->recv, &req->sent);
		ping->sdev += d * d;

		if (rtt_med_i == ping->recv / 2) {
			ping->med = timediff(&req->recv, &req->sent);
		}
		rtt_med_i++;
	}
	ping->sdev = sqrt((1.0 / (double) ping->recv) * ping->sdev);
}
