#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "info_server.h"
#include "common.h"

#include <stdio.h>
#include <string.h>

	
	
static char *
find_info_line(char *buf, size_t len, const char *key)
{
	size_t seek;
	const char *s;

	for (seek = 0, s = buf; seek < len; seek++) {
		if (buf[seek] == '\0') {
			if (strcmp(s, key) == 0) {
				return buf + seek + 1;
			}
			s = buf + seek + 1;
		}
	}
	return NULL;
}



void
info_server_build(struct server_info *info)
{
	char *val;

	if (verbose >= VERBOSE_DEBUG) {
		char *s;
		int i;

		for (i = 0, s = info->data; i < info->ptr; i++) {
			if (info->data[i] == '\0') {
				printf(": %s\n", s);
				s = info->data + i + 1;
			}
		}
	}

	info->hostname = find_info_line(info->data, info->ptr, "hostname");
	info->gamevariant =
		find_info_line(info->data, info->ptr, "gamevariant");
	info->mapname = find_info_line(info->data, info->ptr, "mapname");

	val = find_info_line(info->data, info->ptr, "numplayers");
	if (val != NULL) {
		info->players = atoi(val);
	} else {
		info->players = 0;
	}

	/*
	val = find_info_line(info->data, info->ptr, "\01player_");
	if (val != NULL) {
		int empty = 0;
		val++;
		while (empty == 0 || *val != '\0') {
			printf("%c", *val); fflush(stdout);
			if (*val == '\0') {
				printf(" +++\n");
				info->players++;
				empty = 1;
			} else {
				empty = 0;
			}
			val++;
		}
	}
	*/
}
