#ifndef SERVER_H_
#define SERVER_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#define ADDR_LEN	256
#define SERV_LEN	64

#include "common.h"

#include <netdb.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/types.h>
#include <time.h>


struct request {
	uint32_t	session;
	struct timeval	sent;
	struct timeval	recv;
	enum packet	type;
};


struct ci {
	struct addrinfo	hints;
	struct addrinfo	*res;
	int		read;
	int		write;
};


struct server {
	int		fd;
	struct ci	ci;

	char		addr[ADDR_LEN + 1];
	char		port[SERV_LEN + 1];

	void		*data;

	struct request	*reqs;
	int		req_i;	/* index of sent request */
	int		req_n;	/* number of requests */
	int		req_r;	/* numner of request replies */
};


void server_error(struct server *s, int close_s, const char *msg,
		const char *err);


#endif
